/*
 * Abiturrechner der GTS Offenbach
 * Copyright (C) 2013  Sabine Bergmann
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 * */
  
  import java.io.File;
  import java.io.FileInputStream;
  import java.io.FileOutputStream;
  import java.io.ObjectInputStream;
  import java.io.ObjectOutputStream;
  
  public class Dateioperationen
  {
    public void serializeLeseInDatei(Speicherdaten speicher, File f)
    {
      try
      {
        String filename = f.getPath();
        if (!f.getPath().endsWith(".abi")) filename = f.getPath() + ".abi";
        FileOutputStream fout = new FileOutputStream(filename);
        ObjectOutputStream oos = new ObjectOutputStream(fout);
        oos.writeObject(speicher);
        oos.close();
      }
      catch (Exception ex) {
      }
    }
  
    public Speicherdaten deserializeLeseAusDatei(File f) {
      try {
        FileInputStream fin = new FileInputStream(f.getPath());
        ObjectInputStream ois = new ObjectInputStream(fin);
        Speicherdaten speicher = (Speicherdaten)ois.readObject();
        ois.close();
        return speicher; } catch (Exception ex) {
      }return null;
    }
  }

