/*
 * Abiturrechner der GTS Offenbach
 * Copyright (C) 2013  Sabine Bergmann
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 * */

 
 import java.util.ArrayList;

 
 public class KursVerwaltung
 {
	 public Boolean franz = Boolean.valueOf(false);
	 public Boolean kunst = Boolean.valueOf(false);
	 public Boolean twgq1 = Boolean.valueOf(false);
	 public Boolean twgq2 = Boolean.valueOf(false);
	 public Boolean twgq3 = Boolean.valueOf(false);
	 public Boolean twgq4 = Boolean.valueOf(false);
	 
	 public String lkfach1 = "D";
	 public String lkfachtw = "MB";
	 public String pruef3 = "M";
	 public String pruef4 = "M";
	 public String pruef5 = "M";
	 public String fach345 = this.pruef3 + this.pruef4 + this.pruef5;
	 
	 Fach deutsch = new Fach();
	 Fach englisch = new Fach();
	 Fach powi = new Fach();
	 Fach geschichte = new Fach();
	 Fach relieth = new Fach();
	 Fach mathe = new Fach();
	 Fach phychem = new Fach();
	 Fach sport = new Fach();
	 Fach techTG = new Fach();
	 Fach techTW = new Fach();
	 Fach techTWG = new Fach();
	 Fach kunstFach = new Fach();
	 Fach franzFach = new Fach();
	 ArrayList<Fach> alleFaecher = new ArrayList();
	 ArrayList<Fach> fachLK = new ArrayList();
	 ArrayList<Fach> fachGK = new ArrayList();
	 ArrayList<Kurs> alleFreienKurse = new ArrayList();
	 ArrayList<Kurs> freieKurseA2 = new ArrayList();
	 ArrayList<Kurs> meineWahlKurse = new ArrayList();
	 boolean zuBelegendeBelegt = false;
	 boolean lkUeber5 = true;
	 boolean gkUeber5 = true;
	 Integer lkBereich = Integer.valueOf(0);
	 Integer gkBereich = Integer.valueOf(0);
	 Boolean qualifiziert = Boolean.valueOf(false);
	 
	 Integer ersteNote = Integer.valueOf(0);
	 boolean nachpruefung1 = false;
	 Integer ersteNoteNachpruefung = Integer.valueOf(0);
	 Integer zweiteNote = Integer.valueOf(0);
	 boolean nachpruefung2 = false;
	 Integer zweiteNoteNachpruefung = Integer.valueOf(0);
	 Integer dritteNote = Integer.valueOf(0);
	 boolean nachpruefung3 = false;
	 Integer dritteNoteNachpruefung = Integer.valueOf(0);
	 Integer vierteNote = Integer.valueOf(0);
	 Integer fünfteNote = Integer.valueOf(0);
	 Integer abiPunktzahl = Integer.valueOf(0);
	 Double durchschnitt;
	 String durchschnittsnote;
	 boolean abiUeber5 = false;

	 
	 public void setFranz(Boolean b) {
		 this.franz = b;
	}

	 public void setKunst(Boolean b) {
		this.kunst = b;
	}

	 public void setTwgQ1(Boolean b) {
		this.twgq1 = b;
	}

	 public void setTwgQ2(Boolean b) {
		this.twgq2 = b;
	}

	 public void setTwgQ3(Boolean b) {
		this.twgq3 = b;
	}

	 public void setTwgQ4(Boolean b) {
		this.twgq4 = b;
	}

	 public void setLkfach1(String s) {
		 this.lkfach1 = s;
		this.fach345 = (this.pruef3 + this.pruef4 + this.pruef5);
	}

	 public void setLkfachTW(String s) {
		this.lkfachtw = s;
		this.fach345 = (this.pruef3 + this.pruef4 + this.pruef5);
	}

	 public void setPruef3(String s) {
		this.pruef3 = s;
		this.fach345 = (this.pruef3 + this.pruef4 + this.pruef5);
	}

	 public void setPruef4(String s) {
		this.pruef4 = s;
		this.fach345 = (this.pruef3 + this.pruef4 + this.pruef5);
	}

	 public void setPruef5(String s) {
		this.pruef5 = s;
		this.fach345 = (this.pruef3 + this.pruef4 + this.pruef5);
	}

	 
	 public boolean vergleicheFaecher(String f1, String f2, String f3,
			String f4, String f5)
	 {
		 String[] strings = { f1, f2, f3, f4, f5 };
		 ArrayList vergleicher = new ArrayList();
		 for (int i = 0; i < 5; i++)
		 {
			 String s = strings[i];
			 if (!vergleicher.contains(s))
				vergleicher.add(s);
			else
				 return false;
			 }
		 return true;
		 }

	 
	 public boolean vergleiche345(String fach345)
	 {
		 if (this.lkfach1.equals("D"))
		 {
			 if (!this.franz.booleanValue())
			 {
				 if ((fach345.contains("E")) && (fach345.contains("P"))
						&& (fach345.contains("G")))
					return true;
				 if ((fach345.contains("E")) && (fach345.contains("P"))
						&& (fach345.contains("M")))
					return true;
				 if ((fach345.contains("E")) && (fach345.contains("P"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("E")) && (fach345.contains("G"))
						&& (fach345.contains("M")))
					return true;
				 if ((fach345.contains("E")) && (fach345.contains("G"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("P")) && (fach345.contains("M"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("G")) && (fach345.contains("M"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("E")) && (fach345.contains("P"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("E")) && (fach345.contains("G"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("E")) && (fach345.contains("M"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("E")) && (fach345.contains("N"))
						&& (fach345.contains("L*")))
					return true;
				 if ((fach345.contains("P")) && (fach345.contains("M"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("G")) && (fach345.contains("M"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("M")) && (fach345.contains("N"))
						&& (fach345.contains("L*")))
					return true;
				 
				 if ((fach345.contains("E")) && (fach345.contains("R"))
						&& (fach345.contains("M")))
					return true;
				 if ((fach345.contains("E")) && (fach345.contains("R"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("P")) && (fach345.contains("G"))
						&& (fach345.contains("M")))
					return true;
				 if ((fach345.contains("R")) && (fach345.contains("M"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("E")) && (fach345.contains("R"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("R")) && (fach345.contains("M"))
						&& (fach345.contains("L")))
					return true;
				 }
			 if (this.franz.booleanValue())
			 {
				 if ((fach345.contains("E")) && (fach345.contains("P"))
						&& (fach345.contains("M")))
					return true;
				 if ((fach345.contains("E")) && (fach345.contains("P"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("E")) && (fach345.contains("G"))
						&& (fach345.contains("M")))
					return true;
				 if ((fach345.contains("E")) && (fach345.contains("G"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("P")) && (fach345.contains("M"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("G")) && (fach345.contains("M"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("E")) && (fach345.contains("P"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("E")) && (fach345.contains("G"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("E")) && (fach345.contains("M"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("E")) && (fach345.contains("N"))
						&& (fach345.contains("L*")))
					return true;
				 if ((fach345.contains("P")) && (fach345.contains("M"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("G")) && (fach345.contains("M"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("M")) && (fach345.contains("N"))
						&& (fach345.contains("L*")))
					return true;
				 }
			 }
		 
		 if (this.lkfach1.equals("N"))
		 {
			 if (this.pruef3.equals("M"))
				return false;
			 if (!this.franz.booleanValue())
			 {
				 if ((fach345.contains("D")) && (fach345.contains("E"))
						&& (fach345.contains("P")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("E"))
						&& (fach345.contains("G")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("M"))
						&& (fach345.contains("P")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("M"))
						&& (fach345.contains("G")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("E"))
						&& (fach345.contains("L*")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("M"))
						&& (fach345.contains("L*")))
					return true;
				 
				 if ((fach345.contains("D")) && (fach345.contains("E"))
						&& (fach345.contains("R")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("M"))
						&& (fach345.contains("R")))
					return true;
				 }
			 
			 if (this.franz.booleanValue())
			 {
				 if ((fach345.contains("D")) && (fach345.contains("E"))
						&& (fach345.contains("P")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("E"))
						&& (fach345.contains("G")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("M"))
						&& (fach345.contains("P")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("M"))
						&& (fach345.contains("G")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("E"))
						&& (fach345.contains("L*")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("M"))
						&& (fach345.contains("L*")))
					return true;
				 }
			 }
		 
		 if (this.lkfach1.equals("E"))
		 {
			 if (!this.franz.booleanValue())
			 {
				 if ((fach345.contains("D")) && (fach345.contains("P"))
						&& (fach345.contains("M")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("P"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("G"))
						&& (fach345.contains("M")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("G"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("P"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("G"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("M"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("N"))
						&& (fach345.contains("L*")))
					return true;
				 
				 if ((fach345.contains("D")) && (fach345.contains("P"))
						&& (fach345.contains("G")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("R"))
						&& (fach345.contains("M")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("R"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("R"))
						&& (fach345.contains("L")))
					return true;
				 }
			 if (this.franz.booleanValue())
			 {
				 if ((fach345.contains("D")) && (fach345.contains("P"))
						&& (fach345.contains("M")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("P"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("G"))
						&& (fach345.contains("M")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("G"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("P"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("G"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("M"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("N"))
						&& (fach345.contains("L*")))
					return true;
				 }
			 
			 }
		 
		 if (this.lkfach1.equals("M"))
		 {
			 if (this.pruef3.equals("N"))
				return false;
			 if (!this.franz.booleanValue())
			 {
				 if ((fach345.contains("D")) && (fach345.contains("E"))
						&& (fach345.contains("P")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("E"))
						&& (fach345.contains("G")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("P"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("G"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("E"))
						&& (fach345.contains("L*")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("P"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("G"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("N"))
						&& (fach345.contains("L*")))
					return true;
				 
				 if ((fach345.contains("D")) && (fach345.contains("E"))
						&& (fach345.contains("R")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("P"))
						&& (fach345.contains("G")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("R"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("R"))
						&& (fach345.contains("L")))
					return true;
				 }
			 if (this.franz.booleanValue())
			 {
				 if ((fach345.contains("D")) && (fach345.contains("E"))
						&& (fach345.contains("P")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("E"))
						&& (fach345.contains("G")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("P"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("G"))
						&& (fach345.contains("N")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("E"))
						&& (fach345.contains("L*")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("P"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("G"))
						&& (fach345.contains("L")))
					return true;
				 if ((fach345.contains("D")) && (fach345.contains("N"))
						&& (fach345.contains("L*")))
					return true;
				 }
			 }
		 return false;
		 }

	 
	 public boolean checkKunstTWG()
	 {
		 if ((this.lkfachtw.equals("MB"))
				|| (this.lkfachtw.endsWith("ET")))
		 {
			 if ((this.kunst.booleanValue())
					&& (this.twgq1.booleanValue()))
				return true;
			 if (!this.kunst.booleanValue())
			 {
				 Boolean b = Boolean.valueOf(((this.twgq2
						.booleanValue()) && (this.twgq3.booleanValue()))
						|| ((this.twgq3.booleanValue()) && (this.twgq4
								.booleanValue()))
						|| ((this.twgq2.booleanValue()) && (this.twgq4
								.booleanValue())));
				 if ((this.twgq1.booleanValue()) && (b.booleanValue()))
					return true;
				 }
			 }
		 if (this.lkfachtw.equals("DV"))
		 {
			 if ((this.kunst.booleanValue())
					&& (this.twgq2.booleanValue()))
				return true;
			 if (!this.kunst.booleanValue())
			 {
				 Boolean b = Boolean.valueOf(((this.twgq1
						.booleanValue()) && (this.twgq3.booleanValue()))
						|| ((this.twgq1.booleanValue()) && (this.twgq4
								.booleanValue()))
						|| ((this.twgq3.booleanValue()) && (this.twgq4
								.booleanValue())));
				 if ((this.twgq2.booleanValue()) && (b.booleanValue()))
					return true;
				 }
			 }
		 return false;
		 }

	 
	 public boolean abiKombiErlaubt()
	 {
		 Boolean vergl1 = Boolean.valueOf(vergleicheFaecher(
				this.lkfach1, this.lkfachtw, this.pruef3, this.pruef4,
				this.pruef5));
		 Boolean vergl2 = Boolean.valueOf(vergleiche345(this.fach345));
		 Boolean vergl3 = Boolean.valueOf(checkKunstTWG());
		 if ((vergl1.booleanValue()) && (vergl2.booleanValue())
				&& (vergl3.booleanValue()))
			return true;
		 return false;
		 }

	 
	 public boolean m18mm()
	 {
		 if ((this.twgq1.booleanValue()) && (this.twgq2.booleanValue())
				&& (this.twgq3.booleanValue()) && (this.twgq4.booleanValue()))
			return true;
		 return false;
		 }

	 
	 public int freieKurse()
	 {
		 if (this.lkfach1.equals("D"))
		 {
			 if (!this.franz.booleanValue())
			 {
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("G")))
					return 0;
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("M")))
					return 2;
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("N")))
					return 2;
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("G"))
						&& (this.fach345.contains("M")))
					return 3;
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("G"))
						&& (this.fach345.contains("N")))
					return 3;
				 if ((this.fach345.contains("P"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("N")))
					return 5;
				 if ((this.fach345.contains("G"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("N")))
					return 3;
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("L")))
					return 2;
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("G"))
						&& (this.fach345.contains("L")))
					return 3;
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("L")))
					return 5;
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("N"))
						&& (this.fach345.contains("L*")))
					return 5;
				 if ((this.fach345.contains("P"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("L")))
					return 2;
				 if ((this.fach345.contains("G"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("L")))
					return 3;
				 if ((this.fach345.contains("M"))
						&& (this.fach345.contains("N"))
						&& (this.fach345.contains("L*")))
					return 5;
				 
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("R"))
						&& (this.fach345.contains("M")))
					return 1;
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("R"))
						&& (this.fach345.contains("N")))
					return 1;
				 if ((this.fach345.contains("P"))
						&& (this.fach345.contains("G"))
						&& (this.fach345.contains("M")))
					return 0;
				 if ((this.fach345.contains("R"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("N")))
					return 1;
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("R"))
						&& (this.fach345.contains("L")))
					return 1;
				 if ((this.fach345.contains("R"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("L")))
					return 1;
				 }
			 if (this.franz.booleanValue())
			 {
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("M")))
					return 0;
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("N")))
					return 0;
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("G"))
						&& (this.fach345.contains("M")))
					return 1;
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("G"))
						&& (this.fach345.contains("N")))
					return 1;
				 if ((this.fach345.contains("P"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("N")))
					return 3;
				 if ((this.fach345.contains("G"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("N")))
					return 1;
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("L")))
					return 0;
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("G"))
						&& (this.fach345.contains("L")))
					return 1;
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("L")))
					return 3;
				 if ((this.fach345.contains("E"))
						&& (this.fach345.contains("N"))
						&& (this.fach345.contains("L*")))
					return 3;
				 if ((this.fach345.contains("P"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("L")))
					return 0;
				 if ((this.fach345.contains("G"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("L")))
					return 1;
				 if ((this.fach345.contains("M"))
						&& (this.fach345.contains("N"))
						&& (this.fach345.contains("L*")))
					return 3;
				 }
			 }
		 
		 if (this.lkfach1.equals("N"))
		 {
			 if (!this.franz.booleanValue())
			 {
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("E"))
						&& (this.fach345.contains("P")))
					return 2;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("E"))
						&& (this.fach345.contains("G")))
					return 3;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("P")))
					return 2;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("G")))
					return 3;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("E"))
						&& (this.fach345.contains("L*")))
					return 5;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("L*")))
					return 5;
				 
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("E"))
						&& (this.fach345.contains("R")))
					return 1;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("R")))
					return 1;
				 }
			 
			 if (this.franz.booleanValue())
			 {
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("E"))
						&& (this.fach345.contains("P")))
					return 0;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("E"))
						&& (this.fach345.contains("G")))
					return 1;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("P")))
					return 0;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("G")))
					return 1;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("E"))
						&& (this.fach345.contains("L*")))
					return 3;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("L*")))
					return 3;
				 }
			 }
		 
		 if (this.lkfach1.equals("E"))
		 {
			 if (!this.franz.booleanValue())
			 {
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("M")))
					return 2;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("N")))
					return 2;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("G"))
						&& (this.fach345.contains("M")))
					return 3;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("G"))
						&& (this.fach345.contains("N")))
					return 3;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("L")))
					return 2;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("G"))
						&& (this.fach345.contains("L")))
					return 3;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("L")))
					return 5;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("N"))
						&& (this.fach345.contains("L*")))
					return 5;
				 
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("G")))
					return 0;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("R"))
						&& (this.fach345.contains("M")))
					return 1;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("R"))
						&& (this.fach345.contains("N")))
					return 1;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("R"))
						&& (this.fach345.contains("L")))
					return 1;
				 }
			 if (this.franz.booleanValue())
			 {
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("M")))
					return 0;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("N")))
					return 0;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("G"))
						&& (this.fach345.contains("M")))
					return 1;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("G"))
						&& (this.fach345.contains("N")))
					return 1;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("L")))
					return 0;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("G"))
						&& (this.fach345.contains("L")))
					return 1;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("M"))
						&& (this.fach345.contains("L")))
					return 3;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("N"))
						&& (this.fach345.contains("L*")))
					return 3;
				 }
			 
			 }
		 
		 if (this.lkfach1.equals("M"))
		 {
			 if (!this.franz.booleanValue())
			 {
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("E"))
						&& (this.fach345.contains("P")))
					return 2;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("E"))
						&& (this.fach345.contains("G")))
					return 3;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("N")))
					return 2;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("G"))
						&& (this.fach345.contains("N")))
					return 3;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("E"))
						&& (this.fach345.contains("L*")))
					return 5;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("L")))
					return 2;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("G"))
						&& (this.fach345.contains("L")))
					return 3;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("N"))
						&& (this.fach345.contains("L*")))
					return 5;
				 
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("E"))
						&& (this.fach345.contains("R")))
					return 1;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("G")))
					return 0;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("R"))
						&& (this.fach345.contains("N")))
					return 1;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("R"))
						&& (this.fach345.contains("L")))
					return 1;
				 }
			 if (this.franz.booleanValue())
			 {
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("E"))
						&& (this.fach345.contains("P")))
					return 0;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("E"))
						&& (this.fach345.contains("G")))
					return 1;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("N")))
					return 0;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("G"))
						&& (this.fach345.contains("N")))
					return 1;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("E"))
						&& (this.fach345.contains("L*")))
					return 3;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("P"))
						&& (this.fach345.contains("L")))
					return 0;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("G"))
						&& (this.fach345.contains("L")))
					return 1;
				 if ((this.fach345.contains("D"))
						&& (this.fach345.contains("N"))
						&& (this.fach345.contains("L*")))
					return 3;
				 }
			 }
		 return -1;
		 }

	 
	 public void setDeutsch()
	 {
		 this.deutsch.fachname = "D";
		 this.deutsch.isZuBeleg = true;
		 if (this.lkfach1.equals("D"))
		 {
			 this.deutsch.isLk = true;
			 this.deutsch.mussBeleg = 4;
			 this.deutsch.mussEinbring = 4;
			 }
		 if (this.fach345.contains("D"))
		 {
			 this.deutsch.isAbiGk = true;
			 this.deutsch.isLk = false;
			 this.deutsch.mussBeleg = 4;
			 this.deutsch.mussEinbring = 4;
			 }
		 if ((!this.lkfach1.equals("D"))
				&& (!this.fach345.contains("D")))
		 {
			 this.deutsch.mussBeleg = 4;
			this.deutsch.mussEinbring = 4;
			 this.deutsch.isLk = false;
			 }
		 
		 this.deutsch.setKurseUsage();
		 }

	 
	 public void setEnglisch()
	 {
		 this.englisch.fachname = "E";
		 this.englisch.isZuBeleg = true;
		 if (this.lkfach1.equals("E"))
		 {
			 this.englisch.isLk = true;
			 this.englisch.mussBeleg = 4;
			 this.englisch.mussEinbring = 4;
			 }
		 if (this.fach345.contains("E"))
		 {
			 this.englisch.isAbiGk = true;
			 this.englisch.isLk = false;
			 this.englisch.mussBeleg = 4;
			 this.englisch.mussEinbring = 4;
			 }
		 if ((!this.lkfach1.equals("E"))
				&& (!this.fach345.contains("E")))
		 {
			 this.englisch.mussBeleg = 4;
			this.englisch.mussEinbring = 4;
			 this.englisch.isLk = false;
			 }
		 this.englisch.setKurseUsage();
		 }

	 
	 public void setPoWi()
	 {
		 this.powi.fachname = "P";
		 this.powi.isZuBeleg = true;
		 if (this.fach345.contains("P"))
		 {
			 this.powi.isAbiGk = true;
			 this.powi.mussBeleg = 4;
			 this.powi.mussEinbring = 4;
			 }
		 if (!this.fach345.contains("P"))
		 {
			 this.powi.mussBeleg = 2;
			this.powi.mussEinbring = 1;
			 }
		 this.powi.setKurseUsage();
		 }

	 
	 public void setGeschichte()
	 {
		 this.geschichte.fachname = "G";
		 this.geschichte.isZuBeleg = true;
		 if (this.fach345.contains("G"))
		 {
			 this.geschichte.isAbiGk = true;
			 this.geschichte.mussBeleg = 4;
			 this.geschichte.mussEinbring = 4;
			 }
		 if (!this.fach345.contains("G"))
		 {
			 this.geschichte.mussBeleg = 4;
			this.geschichte.mussEinbring = 2;
			 }
		 this.geschichte.setKurseUsage();
		 }

	 
	 public void setReliEth()
	 {
		 this.relieth.fachname = "R";
		 this.relieth.isZuBeleg = true;
		 if (this.fach345.contains("R"))
		 {
			 this.relieth.isAbiGk = true;
			 this.relieth.mussBeleg = 4;
			 this.relieth.mussEinbring = 4;
			 }
		 if (!this.fach345.contains("R"))
		 {
			 this.relieth.mussBeleg = 4;
			this.relieth.mussEinbring = 0;
			 }
		 this.relieth.setKurseUsage();
		 }

	 
	 public void setMathe()
	 {
		 this.mathe.fachname = "M";
		 this.mathe.isZuBeleg = true;
		 if (this.lkfach1.equals("M"))
		 {
			 this.mathe.isLk = true;
			 this.mathe.mussBeleg = 4;
			 this.mathe.mussEinbring = 4;
			 }
		 if (!this.lkfach1.equals("M"))
		 {
			 this.mathe.isLk = false;
			 this.mathe.mussBeleg = 4;
			 this.mathe.mussEinbring = 4;
			 }
		 if (this.fach345.contains("M"))
			this.mathe.isAbiGk = true;
		 this.mathe.setKurseUsage();
		 }

	 
	 public void setPhyChem()
	 {
		 this.phychem.fachname = "N";
		 this.phychem.isZuBeleg = true;
		 if (this.lkfach1.equals("N"))
		 {
			 this.phychem.isLk = true;
			 this.phychem.mussBeleg = 4;
			 this.phychem.mussEinbring = 4;
			 }
		 if (this.fach345.contains("N"))
		 {
			 this.phychem.isAbiGk = true;
			 this.phychem.isLk = false;
			 this.phychem.mussBeleg = 4;
			 this.phychem.mussEinbring = 4;
			 }
		 if ((!this.lkfach1.equals("N"))
				&& (!this.fach345.contains("N")))
		 {
			 this.phychem.mussBeleg = 4;
			this.phychem.mussEinbring = 4;
			 this.phychem.isLk = false;
			 }
		 this.phychem.setKurseUsage();
		 }

	 
	 public void setSport()
	 {
		 this.sport.fachname = "S";
		 this.sport.isZuBeleg = true;
		 this.sport.mussBeleg = 4;
		this.sport.mussEinbring = 0;
		 this.sport.setKurseUsage();
		 }

	 
	 public void setTechTG()
	 {
		 this.techTG.fachname = "T";
		 this.techTG.isZuBeleg = true;
		 this.techTG.mussBeleg = 4;
		this.techTG.mussEinbring = 2;
		 this.techTG.setKurseUsage();
		 }

	 
	 public void setTechTW()
	 {
		 this.techTW.fachname = "TW";
		 this.techTW.isZuBeleg = true;
		 this.techTW.isLk = true;
		 this.techTW.mussBeleg = 4;
		this.techTW.mussEinbring = 4;
		 this.techTW.setKurseUsage();
		 }

	 
	 public void setTechTWG()
	 {
		 this.techTWG.fachname = "TWG";
		 this.techTWG.isZuBeleg = true;
		 if ((this.lkfachtw.equals("ET"))
				|| (this.lkfachtw.equals("MB")))
			this.techTWG.twgchoice = 1;
		 if (this.lkfachtw.equals("DV"))
			this.techTWG.twgchoice = 2;
		 if (!m18mm())
		 {
			 if (!this.kunst.booleanValue())
			 {
				 this.techTWG.mussBeleg = 3;
				this.techTWG.mussEinbring = 2;
				 }
			 if (this.kunst.booleanValue())
			 {
				 this.techTWG.mussBeleg = 1;
				this.techTWG.mussEinbring = 0;
				 }
			 }
		 if (m18mm())
		 {
			 if (!this.kunst.booleanValue())
			 {
				 this.techTWG.mussBeleg = 4;
				this.techTWG.mussEinbring = 2;
				 }
			 if (this.kunst.booleanValue())
			 {
				 this.techTWG.mussBeleg = 4;
				this.techTWG.mussEinbring = 0;
				 }
			 }
		 }

	 
	 public void setKunstFach()
	 {
		 this.kunstFach.fachname = "K";
		 if (this.kunst.booleanValue())
		 {
			 this.kunstFach.isZuBeleg = true;
			 this.kunstFach.mussBeleg = 2;
			this.kunstFach.mussEinbring = 2;
			 }
		 if (!this.kunst.booleanValue())
		 {
			 this.kunstFach.mussBeleg = 0;
			this.kunstFach.mussEinbring = 0;
			 }
		 }

	 
	 public void setFranzFach()
	 {
		 this.franzFach.fachname = "F";
		 if (this.franz.booleanValue())
		 {
			 this.franzFach.isZuBeleg = true;
			 this.franzFach.mussBeleg = 4;
			this.franzFach.mussEinbring = 2;
			 }
		 this.franzFach.setKurseUsage();
		 }

	 
	 public void setzeAlleFaecher()
	 {
		 setDeutsch();
		 setEnglisch();
		 setPoWi();
		 setGeschichte();
		 setReliEth();
		 setMathe();
		 setPhyChem();
		 
		 setTechTG();
		 
		 setTechTWG();
		 setKunstFach();
		 setFranzFach();
		 setSport();
		 setTechTW();
		 }

	 
	 public void fuelleAlleFaecher()
	 {
		 this.alleFaecher.clear();
		 this.alleFaecher.add(this.deutsch);
		 this.alleFaecher.add(this.englisch);
		 this.alleFaecher.add(this.powi);
		 this.alleFaecher.add(this.geschichte);
		 this.alleFaecher.add(this.relieth);
		 this.alleFaecher.add(this.mathe);
		 this.alleFaecher.add(this.phychem);
		 this.alleFaecher.add(this.techTG);
		 this.alleFaecher.add(this.techTW);
		 this.alleFaecher.add(this.techTWG);
		 this.alleFaecher.add(this.sport);
		 if (this.franz.booleanValue())
			this.alleFaecher.add(this.franzFach);
		 if (this.kunst.booleanValue())
			this.alleFaecher.add(this.kunstFach);
		 }

	 
	 public void setZuBelegendeBelegt()
	 {
		 this.zuBelegendeBelegt = true;
		 for (Fach f : this.alleFaecher)
		 {
			 if (f.belegteKurse.size() < f.mussBeleg)
				this.zuBelegendeBelegt = false;
			 if ((f.fachname.equals("TWG")) && (!f.twg))
				this.zuBelegendeBelegt = false;
			 f.setEndEingebrachte();
			 }
		 }

	 
	 public void setLKGK()
	 {
		 this.fachLK = setLK();
		 this.fachGK = setGK();
		 }

	 
	 public ArrayList<Fach> setLK()
	 {
		 this.fachLK.clear();
		 if (this.deutsch.isLk)
			this.fachLK.add(this.deutsch);
		 if (this.englisch.isLk)
			this.fachLK.add(this.englisch);
		 if (this.mathe.isLk)
			this.fachLK.add(this.mathe);
		 if (this.phychem.isLk)
			this.fachLK.add(this.phychem);
		 this.fachLK.add(this.techTW);
		 return this.fachLK;
		 }

	 
	 public ArrayList<Fach> setGK() {
		 this.fachGK.clear();
		 if (!this.deutsch.isLk)
			this.fachGK.add(this.deutsch);
		 if (!this.englisch.isLk)
			this.fachGK.add(this.englisch);
		 this.fachGK.add(this.powi);
		 this.fachGK.add(this.geschichte);
		 this.fachGK.add(this.relieth);
		 if (!this.mathe.isLk)
			this.fachGK.add(this.mathe);
		 if (!this.phychem.isLk)
			this.fachGK.add(this.phychem);
		 this.fachGK.add(this.techTG);
		 this.fachGK.add(this.techTWG);
		 this.fachGK.add(this.sport);
		 if (this.franz.booleanValue())
			this.fachGK.add(this.franzFach);
		 if (this.kunst.booleanValue())
			this.fachGK.add(this.kunstFach);
		 return this.fachGK;
		 }

	 
	 public void setLkUeber5()
	 {
		 Integer localInteger1;
		this.lkUeber5 = true;
		 Integer zaehler = Integer.valueOf(0);
		 for (Fach f : this.fachLK)
		 {
			 for (Kurs k : f.endEingebrachte)
			 {
				 if (k.note.intValue() >= 5) {
					localInteger1 = zaehler;
					Integer localInteger2 = zaehler = Integer.valueOf(zaehler
							.intValue() + 1);
					 }
				 }
			 }
		 
		 if (zaehler.intValue() < 5)
			this.lkUeber5 = false;
		 }

	 
	 public void setGkUeber5()
	 {
		 this.gkUeber5 = true;
		 Integer localInteger1;
		Integer zaehler = Integer.valueOf(0);
		 for (Fach f : this.fachGK)
		 {
			 for (Kurs k : f.endEingebrachte)
			 {
				 if (k.note.intValue() >= 5) {
					localInteger1 = zaehler;
					Integer localInteger2 = zaehler = Integer.valueOf(zaehler
							.intValue() + 1);
					 }
				 }
			 }
		 if (zaehler.intValue() < 18)
			this.gkUeber5 = false;
		 }

	 
	 public void setLkBereich()
	 {
		 Integer i = Integer.valueOf(0);
		 for (Fach f : this.fachLK)
		 {
			 i = Integer.valueOf(i.intValue() + 2
					* f.summeEndEingebrachte.intValue());
			 }
		 this.lkBereich = i;
		 }

	 
	 public void setGkBereich()
	 {
		 Integer i = Integer.valueOf(0);
		 for (Fach f : this.fachGK)
		 {
			 i = Integer.valueOf(i.intValue()
					+ f.summeEndEingebrachte.intValue());
			 }
		 this.gkBereich = i;
		 }

	 
	 public void setAlleFreienKurse()
	 {
		 this.alleFreienKurse.clear();
		 for (Fach f : this.alleFaecher)
		 {
			 this.alleFreienKurse.addAll(f.freieKurse);
			 }
		 sortiereKurse(this.alleFreienKurse);
		 
		 int freieKurse = freieKurse();
		 if (freieKurse > this.alleFreienKurse.size())
			freieKurse = this.alleFreienKurse.size();
		 int counter = this.alleFreienKurse.size() - freieKurse;
		 this.meineWahlKurse.clear();
		 if ((counter < this.alleFreienKurse.size())
				&& (this.alleFreienKurse.size() > 0))
			this.meineWahlKurse.addAll(this.alleFreienKurse.subList(counter,
					this.alleFreienKurse.size()));
		 
		 for (Kurs k : this.meineWahlKurse)
		 {
			 String s = k.fachname;
			 if (s.equals("D"))
				this.deutsch.setEndEingebrachte(k);
			 if (s.equals("E"))
				this.englisch.setEndEingebrachte(k);
			 if (s.equals("F"))
				this.franzFach.setEndEingebrachte(k);
			 if (s.equals("K"))
				this.kunstFach.setEndEingebrachte(k);
			 if (s.equals("P"))
				this.powi.setEndEingebrachte(k);
			 if (s.equals("G"))
				this.geschichte.setEndEingebrachte(k);
			 if (s.equals("R"))
				this.relieth.setEndEingebrachte(k);
			 if (s.equals("M"))
				this.mathe.setEndEingebrachte(k);
			 if (s.equals("N"))
				this.phychem.setEndEingebrachte(k);
			 if (s.equals("T"))
				this.techTG.setEndEingebrachte(k);
			 if (s.equals("TW"))
				this.techTW.setEndEingebrachte(k);
			 if (s.equals("TWG"))
				this.techTWG.setEndEingebrachte(k);
			 if (s.equals("S"))
				this.sport.setEndEingebrachte(k);
			 }
		 }

	 
	 public void quali()
	 {
		 if ((this.zuBelegendeBelegt) && (this.lkUeber5)
				&& (this.gkUeber5) && (this.lkBereich.intValue() >= 80)
				&& (this.gkBereich.intValue() >= 120))
		 {
			 this.qualifiziert = Boolean.valueOf(true);
			 }
		 }

	 
	 public void belegungEinlesen()
	 {
		 fuelleAlleFaecher();
		 setZuBelegendeBelegt();
		 setLKGK();
		 setAlleFreienKurse();
		 setLkUeber5();
		 setGkUeber5();
		 setLkBereich();
		 setGkBereich();
		 quali();
		 }

	 
	 public Integer setAbiPunktzahl()
	 {
		 Integer eins = Integer.valueOf(0);
		Integer zwei = Integer.valueOf(0);
		Integer drei = Integer.valueOf(0);
		Integer vier = Integer.valueOf(0);
		 Integer fuenf = Integer.valueOf(0);
		 if (this.nachpruefung1)
			eins = Integer
					.valueOf((2 * this.ersteNote.intValue() + this.ersteNoteNachpruefung
							.intValue()) / 3);
		 if (!this.nachpruefung1)
			eins = this.ersteNote;
		 if (this.nachpruefung2)
			zwei = Integer
					.valueOf((2 * this.zweiteNote.intValue() + this.zweiteNoteNachpruefung
							.intValue()) / 3);
		 if (!this.nachpruefung2)
			zwei = this.zweiteNote;
		 if (this.nachpruefung3)
			drei = Integer
					.valueOf((2 * this.dritteNote.intValue() + this.dritteNoteNachpruefung
							.intValue()) / 3);
		 if (!this.nachpruefung3)
			drei = this.dritteNote;
		 vier = this.vierteNote;
		fuenf = this.fünfteNote;
		 this.abiPunktzahl = Integer.valueOf(4 * eins.intValue() + 4
				* zwei.intValue() + 4 * drei.intValue() + 4 * vier.intValue()
				+ 4 * fuenf.intValue());
		 
		 ArrayList<Integer> pruef = new ArrayList<Integer>();
		 pruef.clear();
		 pruef.add(eins);
		pruef.add(zwei);
		pruef.add(drei);
		pruef.add(vier);
		pruef.add(fuenf);
		 this.abiUeber5 = true;
		 int zaehler = 0;
		 for (Integer i : pruef)
		 {
			 if (i.intValue() < 5)
				zaehler += 1;
			 }
		 if (zaehler > 2)
			this.abiUeber5 = false;
		 
		 if ((eins.intValue() < 5) && (zwei.intValue() < 5))
			this.abiUeber5 = false;
		 return this.abiPunktzahl;
		 }

	 
	 public Integer setGesamtPunktzahl()
	 {
		 Integer gesamtPunktzahl = Integer.valueOf(this.gkBereich
				.intValue()
				+ this.lkBereich.intValue() + this.abiPunktzahl.intValue());
		 return gesamtPunktzahl;
		 }

	 
	 public String setDurchschnittsnote()
	 {
		 if (setGesamtPunktzahl().intValue() < 300)
			this.durchschnittsnote = "5";
		 
		 if ((setGesamtPunktzahl().intValue() >= 300)
				&& (setGesamtPunktzahl().intValue() < 301))
			this.durchschnittsnote = "4,0";
		 
		 if ((setGesamtPunktzahl().intValue() >= 301)
				&& (setGesamtPunktzahl().intValue() <= 318))
			this.durchschnittsnote = "3,9";
		 if ((setGesamtPunktzahl().intValue() >= 319)
				&& (setGesamtPunktzahl().intValue() <= 336))
			this.durchschnittsnote = "3,8";
		 if ((setGesamtPunktzahl().intValue() >= 337)
				&& (setGesamtPunktzahl().intValue() <= 354))
			this.durchschnittsnote = "3,7";
		 if ((setGesamtPunktzahl().intValue() >= 355)
				&& (setGesamtPunktzahl().intValue() <= 372))
			this.durchschnittsnote = "3,6";
		 if ((setGesamtPunktzahl().intValue() >= 373)
				&& (setGesamtPunktzahl().intValue() <= 390))
			this.durchschnittsnote = "3,5";
		 if ((setGesamtPunktzahl().intValue() >= 391)
				&& (setGesamtPunktzahl().intValue() <= 408))
			this.durchschnittsnote = "3,4";
		 if ((setGesamtPunktzahl().intValue() >= 409)
				&& (setGesamtPunktzahl().intValue() <= 426))
			this.durchschnittsnote = "3,3";
		 if ((setGesamtPunktzahl().intValue() >= 427)
				&& (setGesamtPunktzahl().intValue() <= 444))
			this.durchschnittsnote = "3,2";
		 if ((setGesamtPunktzahl().intValue() >= 445)
				&& (setGesamtPunktzahl().intValue() <= 462))
			this.durchschnittsnote = "3,1";
		 if ((setGesamtPunktzahl().intValue() >= 463)
				&& (setGesamtPunktzahl().intValue() <= 480))
			this.durchschnittsnote = "3,0";
		 
		 if ((setGesamtPunktzahl().intValue() >= 481)
				&& (setGesamtPunktzahl().intValue() <= 498))
			this.durchschnittsnote = "2,9";
		 if ((setGesamtPunktzahl().intValue() >= 499)
				&& (setGesamtPunktzahl().intValue() <= 516))
			this.durchschnittsnote = "2,8";
		 if ((setGesamtPunktzahl().intValue() >= 517)
				&& (setGesamtPunktzahl().intValue() <= 534))
			this.durchschnittsnote = "2,7";
		 if ((setGesamtPunktzahl().intValue() >= 535)
				&& (setGesamtPunktzahl().intValue() <= 552))
			this.durchschnittsnote = "2,6";
		 if ((setGesamtPunktzahl().intValue() >= 553)
				&& (setGesamtPunktzahl().intValue() <= 570))
			this.durchschnittsnote = "2,5";
		 if ((setGesamtPunktzahl().intValue() >= 571)
				&& (setGesamtPunktzahl().intValue() <= 588))
			this.durchschnittsnote = "2,4";
		 if ((setGesamtPunktzahl().intValue() >= 589)
				&& (setGesamtPunktzahl().intValue() <= 606))
			this.durchschnittsnote = "2,3";
		 if ((setGesamtPunktzahl().intValue() >= 607)
				&& (setGesamtPunktzahl().intValue() <= 624))
			this.durchschnittsnote = "2,2";
		 if ((setGesamtPunktzahl().intValue() >= 625)
				&& (setGesamtPunktzahl().intValue() <= 642))
			this.durchschnittsnote = "2,1";
		 if ((setGesamtPunktzahl().intValue() >= 643)
				&& (setGesamtPunktzahl().intValue() <= 660))
			this.durchschnittsnote = "2,0";
		 
		 if ((setGesamtPunktzahl().intValue() >= 661)
				&& (setGesamtPunktzahl().intValue() <= 678))
			this.durchschnittsnote = "1,9";
		 if ((setGesamtPunktzahl().intValue() >= 679)
				&& (setGesamtPunktzahl().intValue() <= 696))
			this.durchschnittsnote = "1,8";
		 if ((setGesamtPunktzahl().intValue() >= 697)
				&& (setGesamtPunktzahl().intValue() <= 714))
			this.durchschnittsnote = "1,7";
		 if ((setGesamtPunktzahl().intValue() >= 715)
				&& (setGesamtPunktzahl().intValue() <= 732))
			this.durchschnittsnote = "1,6";
		 if ((setGesamtPunktzahl().intValue() >= 733)
				&& (setGesamtPunktzahl().intValue() <= 750))
			this.durchschnittsnote = "1,5";
		 if ((setGesamtPunktzahl().intValue() >= 751)
				&& (setGesamtPunktzahl().intValue() <= 768))
			this.durchschnittsnote = "1,4";
		 if ((setGesamtPunktzahl().intValue() >= 769)
				&& (setGesamtPunktzahl().intValue() <= 786))
			this.durchschnittsnote = "1,3";
		 if ((setGesamtPunktzahl().intValue() >= 787)
				&& (setGesamtPunktzahl().intValue() <= 804))
			this.durchschnittsnote = "1,2";
		 if ((setGesamtPunktzahl().intValue() >= 805)
				&& (setGesamtPunktzahl().intValue() <= 822))
			this.durchschnittsnote = "1,1";
		 if (setGesamtPunktzahl().intValue() >= 823)
			this.durchschnittsnote = "1,0";
		 
		 return this.durchschnittsnote;
		 }

	 
	 public ArrayList<Kurs> sortiereKurse(ArrayList<Kurs> liste)
	 {
		 for (int i = 1; i < liste.size(); i++)
		 {
			 int j = i;
			 while ((j > 0)
					&& (((Kurs) liste.get(j)).note.compareTo(((Kurs) liste
							.get(j - 1)).note) < 0))
			 {
				 Kurs temp = (Kurs) liste.get(j - 1);
				 liste.set(j - 1, liste.get(j));
				 liste.set(j, temp);
				 j--;
				 }
			 }
		 return liste;
		 }
	 
}
