/*
 * Abiturrechner der GTS Offenbach
 * Copyright (C) 2013  Sabine Bergmann
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 * */
  
  import java.io.File;
  import javax.swing.filechooser.FileFilter;
  
  public class FileExtensionFilter extends FileFilter
  {
    public boolean accept(File file)
    {
      return (file.isDirectory()) || (file.getAbsolutePath().endsWith(".abi"));
    }
  
    public String getDescription()
    {
      return "Abirechner-Datei (*.abi)";
    }
  }

